##############################################
package aims2pxe;
##############################################

use strict;

1;

##############################################
sub new
##############################################
{
   my($class, $dbh, $user, $conf) = @_;
   my($self) = bless{
      _DB => $dbh,
      _USER => $user,
      _CONF => $conf,
   }, $class;
   
   return $self;
}

##############################################
sub enable
##############################################
{
   my( $self, $host, $pxeboot, $forever ) = @_;
   
   # Enable the target host for installation with pxeboot

   my $noexpiry="noexpiry=0";

   unless($host){
      die "Error: No targer hostname specified.\n";
   }   
   $host =~ tr/[a-z]/[A-Z]/;

   unless($pxeboot){
     die "Error: No pxeboot target specified.\n";
   }
   $host =~ tr/[a-z]/[A-Z]/;

   if ($forever) { $noexpiry="noexpiry=1"; }
   my $dbh = $self->{_DB};   
   my $sql = "UPDATE pxehosts SET target=(SELECT name FROM pxeboot WHERE name = ?), status=1,enabled=CURRENT_TIMESTAMP,disabled=null,booted=null,synced=0,synced1='N',synced2='N',synced3='N',synced4='N',synced5='N',synced6='N',".$noexpiry." WHERE hostname = ?";
   eval {
      my $prepare = $dbh->prepare($sql);
         $prepare->execute($pxeboot, $host);
   };
   if($@){
      if($@ =~ /TARGET/){
         die "Error: $pxeboot does not exist.\n";
      }
      if($@ =~ $dbh->err){
         die "Database Error: Failed to enable PXE for $host $@.\n";
      }
   }
   
   $self;

}

##############################################
sub disable
##############################################
{
   my( $self, $host ) = @_;
   
   # Set the device to localboot.
   
   unless($host){
      die "Error: Hostname cannot be null.\n";
   }
   $host =~ tr/[a-z]/[A-Z]/;
   
   my $dbh = $self->{_DB};
   eval {
      my $prepare = $dbh->prepare("UPDATE pxehosts SET status=2,target='localboot',disabled=CURRENT_TIMESTAMP,synced=0,synced1='N',synced2='N',synced3='N',synced4='N',synced5='N',synced6='N' WHERE hostname = ?");
         $prepare->execute($host);
   };
   if($@){
      if($@ =~ $dbh->err){
         die "Database Error: Failed to disable PXE for $host $@.\n";
      }
   }

   $self;
}


##############################################
sub build
##############################################
{

   my( $self, $host, $pxeboot ) = @_;  
  
   # Create (pxelinux|elilo) configurations.

   $self;
}

##############################################
sub destroy
##############################################
{
   my( $self, $host ) = @_;

   # Remove PXE configurations from pxelinux.cfg/

   $self;

}
